<%@ Page Language="C#" %>

<!doctype html> 

<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <title>QPR ProcessAnalyzer</title>
  <meta name="robots" content="noindex, nofollow">
  <meta name="apple-mobile-web-app-capable" content="yes" />

  <link rel="shortcut icon" type="image/ico" href="./favicon.ico" />
  <link rel="apple-touch-icon" href="./processanalyzer.png"/>

<script type="text/javascript">
  var IsiPhone = navigator.userAgent.indexOf("iPhone") != -1;
  var IsiPod = navigator.userAgent.indexOf("iPod") != -1;
  var IsiPad = navigator.userAgent.indexOf("iPad") != -1;
  var IsiOS = IsiPhone || IsiPad || IsiPod;
  document.write("<link type='text/css' rel='stylesheet' href='" + (IsiOS ? "./script/pa.ios.css" : "./script/pa.css") + "'>");
</script>
  
<script type="text/javascript" src="script/jquery.js"></script>
<script type="text/javascript" src="script/jquery.form.js"></script>
<script type="text/javascript" src="script/json2.js"></script>
<script type="text/javascript" src="script/jquery.svg.js"></script>
<script type="text/javascript" src="script/jquery.svggraph.js"></script>
<style type="text/css">@import "script/jquery.svg.css";</style> 

<script type="text/javascript">
<!--
  var OP   = (navigator.userAgent.indexOf("Opera") != -1);
  var IEANY= (navigator.userAgent.indexOf("MSIE") != -1) && !OP;

  var _consts = {
    "PermissionType" : {
      "GenericRead" : 1,
      "GenericWrite" : 2,
      "DeleteModel" : 3,
      "CreateModel" : 4,
      "ResetDatabase" : 5,
      "Filtering" : 6,
      "ManageUsers" : 7,
      "SqlImport" : 8,
      "ManageOperations" : 9,
      "ManageViews" : 10
    }
  };
  
  var _client, _cancelOperationClient;
  var _sessionId;
  var _userId;
  var _userPermissions;
  var _currentOperationPrefix;
  var _currentOperationStartTime;
  var _selectedPage = "Authentication";
  var _pages = [
    { "Id": "Authentication", "Label": "Authentication", "Hidden": true },
    { "Id": "GetModels", "Label": "Models" },
    { "Id": "GetProcessAnalysis", "Label": "Process Analysis", "ShowViewIdSelection": true,
        "GetViewType": function () { return "Process Analysis"; },
        "OnClearFilters": function () {
            OnHideSelected(true, OnGetProcessAnalysisAuthenticationFinished);
        }
    },
    { "Id": "GetDurationAnalysis", "Label": "Duration Analysis", "ShowViewIdSelection": true,
        "GetViewType": function () { return "Duration Analysis"; },
        "OnExcludeSelected": function () {
            ApplyAnalysisFilters(0, OnGetDurationAnalysisAuthenticationFinished);
        },
        "OnIncludeOnlySelected": function () {
            ApplyAnalysisFilters(1, OnGetDurationAnalysisAuthenticationFinished);
        },
        "OnClearFilters": function () {
            OnHideSelected(true, OnGetDurationAnalysisAuthenticationFinished);
        }
    },
    { "Id": "GetProfilingAnalysis", "Label": "Profiling Analysis", "ShowViewIdSelection": true,
        "GetViewType": function () { return "Profiling Analysis"; },
        "OnSelectAll": function () {
            $("#GetProfilingAnalysis_resultTable input.SelectedCheckbox").attr("checked", true);
        },
        "OnDeselectAll": function () {
            $("#GetProfilingAnalysis_resultTable input.SelectedCheckbox").attr("checked", false);
        },
        "OnShowPage": GetProfilingAnalysis_OnShowPage,
        "OnViewIdChanged": GetProfilingAnalysis_OnShowPage,
        "OnDrilldownSelected": function () {
            OnStartOperation("Drilldown Selected Objects");

            Authenticate(function (sessionId) {
                SetOperationState("Processing query...");
                analysisDrilledDown = true;

                var selectedCategoriesStr = document.parameters.GetProfilingAnalysis_attribute.value;

                $("#GetProfilingAnalysis_resultTable input.SelectedCheckbox:checked").each(function () {
                    var parts = $(this).attr("id").match(/selectedCheckbox_(.*)/i);
                    if (parts) {
                        selectedCategoriesStr += "," + parts[1];
                    }
                });

                var options = [
            { "Key": "DrilldownSelection", "Value": "true" },
            { "Key": "SelectedAttributeValueCategories", "Value": selectedCategoriesStr },
            { "Key": "AnalysisType", "Value": "5" }
          ];

                _client.GetAnalysis(
            sessionId,
            parseInt(document.parameters.ViewId.value),
            options,
            function (result) {
                $("#GetAnalysis_generatedAnalysisType").val("Cases");
                $("#GetAnalysis_hideSelected, #GetAnalysis_drilldownSelected, #GetAnalysis_selectAll, #GetAnalysis_deselectAll").show();
                $("#GetAnalysis_result").hide();
                CopySimpleDataTableResultToTable(result, $("#GetAnalysis_resultTable"));
                $("#GetAnalysis_resultDiv").show();
                ShowPage("GetAnalysis");
                LogOff(OnEndOperation);
            }, OnRequestError);
            });
        },
        "OnExcludeSelected": function () {
            ApplyAnalysisFilters(0, OnGetProfilingAnalysisAuthenticationFinished);
        },
        "OnIncludeOnlySelected": function () {
            ApplyAnalysisFilters(1, OnGetProfilingAnalysisAuthenticationFinished);
        },
        "OnClearFilters": function () {
            OnHideSelected(true, OnGetProfilingAnalysisAuthenticationFinished);
        }
    },
    { "Id": "GetAnalysis", "Label": "Lists", "ShowViewIdSelection": true,
        "GetViewType": function () {
            return document.parameters.GetAnalysis_generatedAnalysisType.value;
        },
        "OnSelectAll": function () {
            $("#GetAnalysis_resultTable input.SelectedCheckbox").attr("checked", true);
        },
        "OnDeselectAll": function () {
            $("#GetAnalysis_resultTable input.SelectedCheckbox").attr("checked", false);
        },
        "OnDrilldownSelected": function () {
            OnStartOperation("Drilldown Selected Objects");

            Authenticate(function (sessionId) {
                SetOperationState("Processing query...");
                analysisDrilledDown = true;

                var selection = {
                };
                var options = [{ "Key": "DrilldownSelection", "Value": "true"}];
                var analysisType;

                switch ($("#GetAnalysis_generatedAnalysisType").val()) {
                    case "Activities":
                        analysisType = 5;
                        options[options.length] = { "Key": "SelectedActivities", "Value": GetSelectedAnalysisObjectIds().join(",") };
                        break;
                    case "Cases":
                        analysisType = 6;
                        options[options.length] = { "Key": "SelectedCases", "Value": GetSelectedAnalysisObjectIds().join(",") };
                        break;
                    case "Variations":
                        analysisType = 5;
                        options[options.length] = { "Key": "SelectedVariations", "Value": GetSelectedAnalysisObjectIds().join(",") };
                        break;
                }
                options[options.length] = { "Key": "AnalysisType", "Value": analysisType };

                _client.GetAnalysis(
            sessionId,
            parseInt(document.parameters.ViewId.value),
            options,
            function (result) {
                if (analysisType == 6) {
                    $("#GetAnalysis_generatedAnalysisType").val("Events");
                    $("#GetAnalysis_hideSelected, #GetAnalysis_drilldownSelected, #GetAnalysis_selectAll, #GetAnalysis_deselectAll").hide();
                }
                else {
                    $("#GetAnalysis_generatedAnalysisType").val("Cases");
                    $("#GetAnalysis_hideSelected, #GetAnalysis_drilldownSelected, #GetAnalysis_selectAll, #GetAnalysis_deselectAll").show();
                }
                $("#GetAnalysis_result").hide();
                CopySimpleDataTableResultToTable(result, $("#GetAnalysis_resultTable"));
                $("#GetAnalysis_resultDiv").show();
                ShowPage("GetAnalysis");
                LogOff(OnEndOperation);
            }, OnRequestError);
            });
        }
    },
    { "Id": "ImportModel", "Label": "Import Model", "Hidden": true },
    { "Id": "OperationStatus", "Label": "Operation Status", "Hidden": false,
        "IsPageHidden": function () {
            return !CheckPermissionForUser(_consts.PermissionType.ManageOperations);
        }
    }
  ];

  function trim(s) {
    return s.replace(/^\s\s*/, '').replace(/\s\s*$/, '');
  }

  [].indexOf || (Array.prototype.indexOf = function(v,n){
    n = (n==null)?0:n; var m = this.length;
    for(var i = n; i < m; i++)
      if(this[i] == v)
         return i;
    return -1;
  });

 // Copied from http://www.javascripttoolbox.com/lib/date/index.php
  // ------------------------------------------------------------------
  // formatDate (date_object, format)
  // Returns a date in the output format specified.
  // The format string uses the same abbreviations as in getDateFromFormat()
  // ------------------------------------------------------------------
  // Format a date into a string using a given format string
  Date.prototype.format = function(format) {
    format=format+"";
    var result="";
    var i_format=0;
    var c="";
    var token="";
    var y=this.getYear()+"";
    var M=this.getMonth()+1;
    var d=this.getDate();
    var E=this.getDay();
    var H=this.getHours();
    var m=this.getMinutes();
    var s=this.getSeconds();
    var yyyy,yy,MMM,MM,dd,hh,h,mm,ss,ampm,HH,H,KK,K,kk,k;
    // Convert real date parts into formatted versions
    var value=new Object();
    if (y.length < 4) {
      y=""+(+y+1900);
    }
    value["y"]=""+y;
    value["yyyy"]=y;
    value["yy"]=y.substring(2,4);
    value["M"]=M;
    value["MM"]=Date.LZ(M);
    value["MMM"]=Date.monthNames[M-1];
    value["NNN"]=Date.monthAbbreviations[M-1];
    value["d"]=d;
    value["dd"]=Date.LZ(d);
    value["E"]=Date.dayAbbreviations[E];
    value["EE"]=Date.dayNames[E];
    value["H"]=H;
    value["HH"]=Date.LZ(H);
    if (H==0){
      value["h"]=12;
    }
    else if (H>12){
      value["h"]=H-12;
    }
    else {
      value["h"]=H;
    }
    value["hh"]=Date.LZ(value["h"]);
    value["K"]=value["h"]-1;
    value["k"]=value["H"]+1;
    value["KK"]=Date.LZ(value["K"]);
    value["kk"]=Date.LZ(value["k"]);
    if (H > 11) { 
      value["a"]="PM"; 
    }
    else { 
      value["a"]="AM"; 
    }
    value["m"]=m;
    value["mm"]=Date.LZ(m);
    value["s"]=s;
    value["ss"]=Date.LZ(s);
    while (i_format < format.length) {
      c=format.charAt(i_format);
      token="";
      while ((format.charAt(i_format)==c) && (i_format < format.length)) {
        token += format.charAt(i_format++);
      }
      if (typeof(value[token])!="undefined") { 
        result=result + value[token]; 
      }
      else { 
        result=result + token; 
      }
    }
    return result;
  };

  function ArrayToString(arrayToConvert)
  {
    return arrayToConvert.slice(0, 32) + "...";
  }
  
  function sGetButtonHTML(vsLabel, vsLinkURL, vsStyle, vsTarget)
  {
    if (!vsStyle)
      vsStyle = "Button";
    if (!vsLabel)
      vsLabel = "&nbsp;";
    var sLink;
    if (vsLinkURL && (vsLinkURL.length > 0))
      sLink = " href='" + vsLinkURL + "'";
    else
      sLink = "";
    if (vsTarget)
      sLink += " target='" + vsTarget + "'";
    return "<a" + sLink + " class='" + vsStyle + "'>[&nbsp;" + vsLabel + "&nbsp;]<\/a>";
  }

  function GetTableAs2DimensionalArray(columns)
  {
    var result = new Array();
    var i = 0;
    while (eval("typeof(document.parameters." + columns[0] + (i + 1).toString() + ") !== \"undefined\"")) {
      var row = new Array();
      for (var j = 0; j < columns.length; ++j)
        row.push(eval("document.parameters." + columns[j] + (i + 1).toString() + ".value"));
      result.push(row);
      ++i;
    }
    return result;
  }

  function HideAll() 
  {
    for (var i = 0; i < _pages.length; ++i) {
      var oDiv = document.getElementById(_pages[i].Id + "_Parameters");
      if (oDiv)
        oDiv.style.display = "none";
    }
  }

  function oGetPageDiv(pageLabel) {
      return document.getElementById(pageLabel + "_Parameters");
  }

  function sGetPageButtonHTML(page) {
    var className = page.Hidden ? "HiddenButton" : ((_selectedPage == page.Id) ? "SelectedButton" : "Button");
    return sGetButtonHTML(page.Label, "javascript:ShowPage(\"" + page.Id + "\")", className);
  }

  function GetMethodURL(methodName, params)
  {
    return Sys.Net.WebRequest._createUrl(_client._get_path() + "/" + methodName, params); 
  }

  function GeneratePageLinks(fromOnLoad) {
      var html = "";
      for (var i = 0; i < _pages.length; ++i) {
        var page = _pages[i];
        if (page.ShowAlways || (!fromOnLoad && ((typeof(page.IsPageHidden) === "undefined") || !page.IsPageHidden())))
          html += sGetPageButtonHTML(page);
      }
      var div = document.getElementById("pageSelector");
      div.innerHTML = html;
  }

  function GetPageById(pageId)
  {
    for (var i = 0; i < _pages.length; ++i) {
      var page = _pages[i];
      if (page.Id == pageId)
        return page;
    }
  }
  
  function ShowPage(pageId, fromOnLoad) 
  {
    var page = GetPageById(pageId);
    if (typeof (page.OnPreShowPage) !== "undefined") 
    {
      if (page.OnPreShowPage())
        return;
    }

    HideAll();
    var oDiv = oGetPageDiv(pageId);
    oDiv.style.display = "block";
    _selectedPage = pageId;
    GeneratePageLinks(fromOnLoad);

    if (typeof(page.OnShowPage) !== "undefined")
      page.OnShowPage();

    if (page.ShowViewIdSelection && CheckPermissionForUser(_consts.PermissionType.ManageOperations))
      $("#ViewId_Parameters").show();
    else
      $("#ViewId_Parameters").hide();
  }

  function GenerateTable(numRows, labels, names, initValues) 
  {
    var sResult = "<table style=\"width: 100%\"><tr>";
    for (var i = 0; i < labels.length; ++i)
        sResult += "<th>" + labels[i] + "<\/th>";
    sResult += "<\/tr>";

    for (var i = 0; i < numRows; ++i) 
    {
      sResult += "<tr>";
      for (var j = 0; j < names.length; ++j) 
      {
        sResult += "<td>";
        if (initValues[i]) {
          sResult += "<input type=\"text\" " +
                  "name=\"" + names[j] + (i + 1).toString() + "\" " +
                  "value=\"" + initValues[i][j] + "\" " +
                  "style=\"width:100%\" />";
        }
        else {
          sResult += "<input type=\"text\" " +
                  "name=\"" + names[j] + (i + 1).toString() + "\" " +
                  "value=\"\" " +
                  "style=\"width:100%\" />";
        }
        sResult += "<\/td>";
      }
      sResult += "<\/tr>";
    }
    sResult += "<\/table>";
    return sResult;
  }

  function SetTableContentClass(htmlTable, contentClass)
  {
    htmlTable.removeClass("Events");
    htmlTable.removeClass("Activities");
    htmlTable.removeClass("Cases");
    htmlTable.removeClass("Variations");
    htmlTable.removeClass("Models");
    htmlTable.addClass(contentClass);
  }
  
  function CopySimpleDataTableResultToTable(result, resultElement)
  {
    resultElement.empty();
    if (!result.Contents)
      return;
    SetTableContentClass(resultElement, result.Contents.Name);
    
    $("<caption></caption>").text("Analysis Type: " + result.Contents.Name + (analysisDrilledDown ? " (drilldown)" : "")).appendTo(resultElement);
    var htmlTbody = $("<tbody></tbody>");
    var idColumnId;
    var showSelectControls = result.Contents.Name != "Events";

    if (showSelectControls)
      $("<th><\th>").text("Select").appendTo(htmlTbody);

    $.each(result.Contents.Columns, function (id, column) {	
      if (column.Caption == "Id")
        idColumnId = id;
      $("<th><\th>").text(column.Caption).appendTo(htmlTbody);
    }); 
      
    $.each(result.Contents.Rows, function (id, row) {	
      var htmlRow = $("<tr></tr>");
      var htmlSelectCell;
      if (showSelectControls) {
        htmlSelectCell = $("<td></td>");
        htmlSelectCell.appendTo(htmlRow);
      }
      
      var currentId;
      $.each(row, function (id, cell) {
        var htmlCell = $("<td></td>");
        var cellText = cell.substring(1);
        htmlCell.text(cellText);

        if (id == idColumnId) {
//            htmlCell.attr("id", "idColumn");
          currentId = cellText;
        }
        htmlCell.appendTo(htmlRow);
      });

      if (showSelectControls) {
        var checkbox = $("<input type=\"checkbox\" />").attr("id", "selectedCheckbox_" + currentId).addClass("SelectedCheckbox");
        checkbox.appendTo(htmlSelectCell);
      }

      htmlRow.appendTo(htmlTbody);
    }); 

    resultElement.append(htmlTbody);
  }

  function CopyObjectListToTable(tableCaption, contentClass, result, resultElement, extraColumns, columnOrder, parentIds)
  {
    if (!parentIds) {
      resultElement.empty();
      SetTableContentClass(resultElement, contentClass);
      $("<caption></caption>").text(tableCaption).appendTo(resultElement);
    }

    var columnPrefix = parentIds ? parentIds + "." : "";
    var currentColumnOrder;

    if (columnOrder) {
      currentColumnOrder = [];
      $.each(columnOrder, function (id, column) {	
        if (column.substr(0, columnPrefix.length) == columnPrefix) {
          var currentColumn = column.substr(columnPrefix.length);
          if (currentColumn.indexOf(".") == -1) {
            currentColumnOrder[currentColumnOrder.length] = currentColumn;
          }
        }
      }); 
    }
    
    var htmlTbody = $("<tbody></tbody>");
    if (result.length > 0) {
      if ($.isArray(extraColumns)) {
        $.each(extraColumns, function (id, column) {
          if (column.Caption && column.First)
            $("<th><\th>").text(column.Caption).appendTo(htmlTbody);
        });
      }

      if (currentColumnOrder) {
        $.each(currentColumnOrder, function (id, column) {	
          if (column != "__type")
            $("<th><\th>").text(column).appendTo(htmlTbody);
        }); 
      }
      else {
        $.each(result[0], function (id, column) {	
          if (id != "__type")
            $("<th><\th>").text(id).appendTo(htmlTbody);
        }); 
      }
      
      if ($.isArray(extraColumns)) {
        $.each(extraColumns, function (id, column) {	
          if (column.Caption && !column.First)
            $("<th><\th>").text(column.Caption).appendTo(htmlTbody);
        });
      }

      $.each(result, function (id, model) {	
        var htmlRow = $("<tr></tr>");
        var currentId;

        $.each(model, function (id, cell) {
          if (id == "Id")
            currentId = cell;
        });
      
        if ($.isArray(extraColumns)) {
          $.each(extraColumns, function (id, column) {
            if (column.Caption && column.First) {
              var htmlCell = $("<td></td>");
              column.Generator(currentId, htmlCell);
              htmlCell.appendTo(htmlRow);
            }
          });
        }

        var addCell = function(id, cell) {
          var htmlCell = $("<td></td>");
          if ($.isArray(cell)) {
            var htmlSubTable = $("<table></table>")
              .attr("cellpadding", "0")
              .attr("cellspacing", "0")
              .appendTo(htmlCell);
            var extraSubColumns = $.grep(extraColumns, function (column) {
              return !!column["ExtraColumnsFor_" + id];
            });
            CopyObjectListToTable(tableCaption, contentClass, cell, htmlSubTable, $.isArray(extraSubColumns) ? extraSubColumns[0]["ExtraColumnsFor_" + id] : null, columnOrder, parentIds ? parentIds + "." + id : id);
          }
          else {
            if ((typeof (cell) === "string") && cell.match(/\/Date\((\d+)\)\//gi)) {
              cell = (new Date(parseInt(jsonDate.substr(6)))).format("HH:mm:ss dd.MM.yyyy");
            }
            else if (cell instanceof Date) {
              cell = cell.format("HH:mm:ss dd.MM.yyyy");
            }
              
            htmlCell.text("" + cell);
          }
          htmlCell.appendTo(htmlRow);
        };
        
        if (currentColumnOrder) {
          $.each(currentColumnOrder, function (id, columnName) {
            var cell = model[columnName];
            if (typeof(cell) !== "undefined") {
              addCell(columnName, cell);
            }
          });
        }
        else {
          $.each(model, function (id, cell) {
            if (id != "__type") {
              addCell(id, cell);
            }
          });
        }

        if ($.isArray(extraColumns)) {
          $.each(extraColumns, function (id, column) {
            if (column.Caption && !column.First) {
              var htmlCell = $("<td></td>");
              column.Generator(currentId, htmlCell);
              htmlCell.appendTo(htmlRow);
            }
          });
        }
        htmlRow.appendTo(htmlTbody);
      }); 
    }

    resultElement.append(htmlTbody);
  }
  
  function CheckPermissionForUser(permissionType)
  {
    if ($.isArray(_userPermissions))
      return _userPermissions.indexOf(permissionType) != -1;
    return false;
  }

  function SetPasswordBoxType(type)
  {
    try {
      var passwordBox = document.getElementsByName('Authentication_password')[0];
      passwordBox.type = type;
    } catch (err) {}
  }
  
  function SelectDefaultView()
  {
    var first = $('input:radio[name="selectedViewId"]').get(0);
    if (first)
      document.parameters.ViewId.value = first.value;
    OnViewIdInputChanged();
  }

  function OnViewIdInputChanged()
  {
    $('input:radio[name="selectedViewId"]').filter('[value!="' + document.parameters.ViewId.value + '"]').attr('checked', false);
    $('input:radio[name="selectedViewId"]').filter('[value="' + document.parameters.ViewId.value + '"]').attr('checked', true);
    var page = GetPageById(_selectedPage);
    if (typeof(page.OnViewIdChanged) !== "undefined")
      page.OnViewIdChanged();
  }
 
  var _buttonsDisabledByOperation;
 
  function OnStartOperation(operationPrefix)
  {
    _currentOperationPrefix = operationPrefix;
    _currentOperationStartTime = new Date();
    $("#CancelOperationDiv").show();
    if (!_buttonsDisabledByOperation) {
      _buttonsDisabledByOperation = $('input').filter(':enabled').filter('[id!="CancelButton"]').not("#importForm input");
    }
    _buttonsDisabledByOperation.attr("disabled", "disabled");
  }
  
  function OnEndOperation()
  {
    $("#CancelOperationDiv").hide();
    SetOperationState("Idle");

    _buttonsDisabledByOperation.removeAttr("disabled");
    _buttonsDisabledByOperation = null;

    var undef;
    var endTime = new Date();
    $("#ElapsedTime").html("Processing took " + ((endTime.getTime() - _currentOperationStartTime.getTime()) / 1000) + " seconds.");
    _currentOperationPrefix = undef;
  }
  
  function SetOperationState(state)
  {
    var stateElement = document.getElementById("OperationState");
    stateElement.innerHTML = state;
  }
  
  function OnRequestError(result)
  {
    alert("Exception occurred while processing request:\r\n" + JSON.stringify(result, null, '\t'));
    OnEndOperation();
  }
  
  function DictionaryToAssociativeArray(dictionary)
  {
    var result = [];
    $.each(dictionary, function (id, item) {
      result[item.Key] = item.Value;
    });
    return result;
  }
  
  function Authenticate(AuthenticationFinishedHandler)
  {
    if (_sessionId)
      AuthenticationFinishedHandler(_sessionId);
    else {
      SetOperationState("Authenticating...");
      _client.Authenticate(
        document.Authentication_form.Authentication_logonName.value, 
        document.Authentication_form.Authentication_password.value,
        [ { "Key" : "ClientType", "Value" : "WebClient" },
          { "Key" : "UserAgent", "Value" : navigator.userAgent } ],
        function (sessionData) {
          sessionData = DictionaryToAssociativeArray(sessionData);
          _userId = parseInt(sessionData["UserId"]);
          _sessionId = sessionData["SessionId"];
          AuthenticationFinishedHandler(_sessionId);
        },
        OnRequestError);
    }
  }

  function LogOff(LogOffFinishedHandler)
  {
    SetOperationState("Finishing session...");
    if (_sessionId) {
      _client.LogOff(_sessionId,
                     LogOffFinishedHandler, OnRequestError);
      _sessionId = null;
    }
  }

  function OnLogOn()
  {
    OnStartOperation("Log On");
    Authenticate(OnLogOnFinished);
  }
  
  function OnLogOnFinished()
  {
    _client.GetPermissionsForUser(
      _sessionId, 
      _userId,
      [],
      function (result) {
        _userPermissions = result;
        ShowPage("GetModels");
        OnGetModelsFinished(_sessionId, function () {
          SelectDefaultView();
        });
      }, OnRequestError);
  }

  function OnGetModels()
  {
    OnStartOperation("GetModels");
    Authenticate(OnGetModelsFinished);
  }
    
  function OnGetModelsFinished(sessionId, callbackFunc) 
  {
    SetOperationState("Processing query...");
    _client.GetModels(
      sessionId,
      null,
      [{"Key" : "PublicViewsOnly", "Value" : "true"}],
      function (result) {
        $("#GetModels_result").hide();
        CopyObjectListToTable("Models", "Models", result, $("#GetModels_resultTable"),
          [{
            "Caption":"Export", 
            "Generator":function (id, parentElement) {
              var button = $("<input type=\"button\" />").val("Export").click(function () {
                OnGetModelAsStream(id);
              });
              button.appendTo(parentElement);
              }
            },
            {
            "Caption":"Delete Model", 
            "Generator":function (id, parentElement) {
              var button = $("<input type=\"button\" />").val("Delete").click(function () {
                OnDeleteSelectedModel(id, OnGetModels);
              });
              button.appendTo(parentElement);
              }
            },
            {
            "ExtraColumnsFor_Views" : [
                {
                  "First":true,
                  "Caption":"Selected", 
                  "Generator":function (id, parentElement) {
                    var radioButton = $("<input type=\"radio\" name=\"selectedViewId\" value=\"" + id + "\" />").change(function () {
                      document.parameters.ViewId.value = id;
                    });
                    radioButton.appendTo(parentElement);
                  }
                }
              ]
            }
          ], 
          ["Id", "Name", "LastModifiedBy", "LastModifiedDate", "NEvents", "NCases", "NActivities", "Views", "Views.Id", "Views.Name", "Views.LastModifiedBy", "Views.LastModifiedDate"]
        );
        $("#GetModels_resultDiv").show();

    //    var resultElement = document.getElementById("GetModels_result");
    //    resultElement.value = JSON.stringify(result, null, '\t');

        LogOff(OnEndOperation);
        if (callbackFunc)
          callbackFunc();
        else
          OnViewIdInputChanged()
      }, OnRequestError);
  }
  
  function OnOpenImportModelView()
  {
    ShowPage("ImportModel");
  }

  function OnDeleteSelectedModel(modelId, callback)
  {
    OnStartOperation("DeleteSelectedModel");
    Authenticate(function (sessionId) { 
      SetOperationState("Processing query...");
      _client.DeleteModel(
        sessionId,
        modelId, 
        [ { "Key" : "ModelIdUsed", "Value" : "true" } ],
        function () {
          LogOff(OnEndOperation);
          callback();
        }, OnRequestError);
    });
  }

  var analysisDrilledDown;

  function OnGetAnalysis()
  {
    OnStartOperation("Get Analysis");
    Authenticate(function (sessionId) {
      SetOperationState("Processing query...");
      analysisDrilledDown = false;

      _client.GetAnalysis(
        sessionId,
        parseInt(document.parameters.ViewId.value), 
        GetViewProperties([{"Key" : "AnalysisType", "Value" : document.parameters.GetAnalysis_analysisType.value }]),
        function (result) {
          var analysisTypeAsString = trim($("#GetAnalysis_analysisType option:selected").text());
          $("#GetAnalysis_generatedAnalysisType").val(analysisTypeAsString);

          if (result.Type == 0) {
            $("#GetAnalysis_resultDiv").hide();
            var resultElement = $("#GetAnalysis_result");
            resultElement.val(JSON.stringify(result, null, '\t')).show();
          }
          else {
            $("#GetAnalysis_result").hide();
            CopySimpleDataTableResultToTable(result, $("#GetAnalysis_resultTable"));
            $("#GetAnalysis_hideSelected, #GetAnalysis_drilldownSelected, #GetAnalysis_selectAll, #GetAnalysis_deselectAll").show();
            $("#GetAnalysis_resultDiv").show();
          }
          LogOff(OnEndOperation);
        }, OnRequestError);
    });
  }

  function GetSelectedAnalysisObjectIds()
  {
    var result = [];
    $("#GetAnalysis_resultTable input.SelectedCheckbox:checked").each(function () {
      var parts = $(this).attr("id").match(/selectedCheckbox_(.*)/i);
      if (parts)
        result[result.length] = parseInt(parts[1]);
    });
    return result;
  }
 
  function OnSelectAll()
  {
    var page = GetPageById(_selectedPage);
    if (typeof(page.OnSelectAll) !== "undefined")
      page.OnSelectAll();
  }
  
  function OnDeselectAll()
  {
    var page = GetPageById(_selectedPage);
    if (typeof(page.OnDeselectAll) !== "undefined")
      page.OnDeselectAll();
  }

  function OnClearFilters()
  {
    var page = GetPageById(_selectedPage);
    if (typeof(page.OnClearFilters) !== "undefined")
      page.OnClearFilters();
  }
  
  function OnHideSelected(clearAllFilters, clearFiltersFinishedFunc)
  {
    OnStartOperation("Hide Selected Objects");
    Authenticate(function (sessionId) { 
      SetOperationState("Processing query...");

      var options = [];
      if (analysisDrilledDown)
        options.push({ "Key" : "AddToExistingFilters", "Value" : "true" });
      
      _client.ImportHiddenIds(
        sessionId,
        parseInt(document.parameters.ViewId.value), 
        clearAllFilters ? "" : document.parameters.GetAnalysis_generatedAnalysisType.value,
        clearAllFilters ? [] : GetSelectedAnalysisObjectIds(),
        options,
        function (result) { 
          document.parameters.ViewId.value = result;
          if (clearFiltersFinishedFunc)
            clearFiltersFinishedFunc(_sessionId);
          else
            LogOff(OnEndOperation);
          OnViewIdInputChanged();
        }, OnRequestError);
    });
  }

  function OnDrilldownSelected()
  {
    var page = GetPageById(_selectedPage);
    if (typeof(page.OnDrilldownSelected) !== "undefined")
      page.OnDrilldownSelected();
  }
  
  function OnExcludeSelected()
  {
    var page = GetPageById(_selectedPage);
    if (typeof(page.OnExcludeSelected) !== "undefined")
      page.OnExcludeSelected();
  }

  function OnIncludeOnlySelected()
  {
    var page = GetPageById(_selectedPage);
    if (typeof(page.OnIncludeOnlySelected) !== "undefined")
      page.OnIncludeOnlySelected();
  }

  function OnGetProcessAnalysis()
  {
    OnStartOperation("GetProcessAnalysis");
    Authenticate(OnGetProcessAnalysisAuthenticationFinished);
  }

  function OnGetProcessAnalysisAuthenticationFinished(sessionId)
  {
    SetOperationState("Processing query...");

    var options = [ { "Key" : "MinTransitionUsagePercentage", "Value" : "" + parseFloat(document.parameters.GetProcessAnalysis_minFlowVolume.value) / 100 },
                    { "Key" : "IncludeStatistics",            "Value" : document.parameters.GetProcessAnalysis_includeStatistics.checked ? "true" : "false" }, 
                    { "Key" : "IncludeLayout",                "Value" : document.parameters.GetProcessAnalysis_includeLayout.checked ? "true" : "false" }, 
                    { "Key" : "ProcessAnalysisType",          "Value" : document.parameters.GetProcessAnalysis_analysisType.value },
                    { "Key" : "TransitionType",               "Value" : document.parameters.GetProcessAnalysis_transitionType.value },
                    { "Key" : "UseMedians",                   "Value" : document.parameters.GetProcessAnalysis_useMedians.checked ? "true" : "false" },
                    { "Key" : "AnalysisType",                 "Value" : 0 }                    
    ];

    _client.GetAnalysis(
      sessionId,
      parseInt(document.parameters.ViewId.value), 
      options,
      function (result) {
        $("#GetProcessAnalysis_resultDiv").show();
        $("#GetProcessAnalysis_drilldownButtonsDiv").show();
        var resultElement = $("#GetProcessAnalysis_result");
        resultElement.val(JSON.stringify(result, null, '\t'));

        var resultSvgDiv = $("#GetProcessAnalysis_resultSvgDiv");
        if (result.Layout) {
          var extents = result.Layout.Extents;
          resultSvgDiv.css("width", (extents.x * 2 + extents.width) + "px");
          resultSvgDiv.css("height", (extents.y * 2 + extents.height) + "px");
          resultSvgDiv.svg("destroy");
          resultSvgDiv.svg(function (svgCanvas) { DrawLayoutAsSvg(result.Layout, svgCanvas); });
          arrows = [];
          selectedActivities = [];
          selectedTransitions = [];
          resultSvgDiv.show();
          $("#GetProcessAnalysis_resultImage").hide();
       }
        else {
          resultSvgDiv.hide();
          resultElement.show();
          $("#GetProcessAnalysis_resultImage").hide();
        }
        LogOff(OnEndOperation);
      }, OnRequestError);
  }

  function OnGetDurationAnalysis_useDurationLimitChanged()
  {
    $("#GetDurationAnalysis_durationLimit").attr("disabled", !$("#GetDurationAnalysis_useDurationLimit").attr("checked"));
  }

  var selectionForDurationAnalysis;
  
  function OnGetDurationAnalysis()
  {
    OnStartOperation("OnGetDurationAnalysis");
    Authenticate(OnGetDurationAnalysisAuthenticationFinished);
  }
  
  function CopyObjectSelectionTo(selection, targetOptions)
  {
    if (selection) {
      if (selection.Transitions) {
        var value = "";
        for (var i = 0; i < selection.Transitions.length; ++i) {
          var transition = selection.Transitions[i];
          if (value)
            value += ",";
          value += transition[0] + ":" + transition[1];
        }
        targetOptions[targetOptions.length] = { "Key" : "SelectedTransitions", "Value" : value };
      }
      if (selection.Activities) {
        targetOptions[targetOptions.length] = { "Key" : "SelectedActivities", "Value" : selection.Activities.join(",") };
      }
    }

    if (selectionForDurationAnalysis && selectionForDurationAnalysis.Transitions.length > 0) {
      targetOptions[targetOptions.length] = { "Key" : "DurationFromTransition", "Value" : true };
    }

    return targetOptions;
  }

  function OnGetDurationAnalysisAuthenticationFinished(sessionId)
  {
    SetOperationState("Processing query...");

    var options = [ { "Key" : "Granularity",       "Value" : document.parameters.GetDurationAnalysis_groupBy.value },
        { "Key": "AnalysisType", "Value": 9 },
        { "Key": "ForceAnalysisResultType", "Value": 1 }
        ];
    if (document.parameters.GetDurationAnalysis_useDurationLimit.checked)
      options[options.length] = { "Key" : "MaximumDuration", "Value" : parseInt(document.parameters.GetDurationAnalysis_durationLimit.value) };

    _client.GetAnalysis(
      sessionId,
      parseInt(document.parameters.ViewId.value), 
      CopyObjectSelectionTo(selectionForDurationAnalysis, options),
      function (result) {
        ShowPage("GetDurationAnalysis");
        $("#GetDurationAnalysis_resultDiv").show();
        $("#GetDurationAnalysis_drilldownButtonsDiv").show();
        if (selectionForDurationAnalysis)
          $("#GetDurationAnalysis_clearSelection").show();
        else
          $("#GetDurationAnalysis_clearSelection").hide();
        var resultElement = $("#GetDurationAnalysis_result");
        resultElement.val(JSON.stringify(result, null, '\t'));
        var resultSvgDiv = $("#GetDurationAnalysis_resultSvgDiv");
        resultSvgDiv.css("width", "960px").css("height", "600px");
        resultSvgDiv.svg("destroy");
        resultSvgDiv.svg(function (svgCanvas) { DrawDurationAnalysisAsSvg(result, svgCanvas); });
        selectedTimespans = [];
        resultSvgDiv.show();
        LogOff(OnEndOperation);
      }, OnRequestError);
  }
  
  var selectedTimespans = [];
  
  function log2(x)
  {
    return Math.log(x) / Math.log(2);
  }
  
  function DrawDurationAnalysisAsSvg(result, svgCanvas)
  {
    var MAXIMUM_NUMBER_OF_LABELS = 40;
    var ratio = 1, x = result.Durations.length;
    var mod = Math.pow(parseInt(log2(Math.ceil(result.Durations.length / MAXIMUM_NUMBER_OF_LABELS))) + 1, 2);
    var series = [], labels = [], axisLabels = [];
    var maximumCount = 0;
    $.each(result.Durations, function (id, duration) {
      series[series.length] = duration.Count;
      labels[labels.length] = "" + duration.Value;
      if (axisLabels.length % mod == 0)
        axisLabels[axisLabels.length] = "" + duration.Value;
      else
        axisLabels[axisLabels.length] = "";

      if (duration.Count > maximumCount)
        maximumCount = duration.Count;
    });
    
    maximumCount *= 1.1;
    if (maximumCount < 10)
      maximumCount = 10;

    var majorTicks = 5;
    var minorTicks = 1;
    var cCount = maximumCount;
    while (cCount > 50) {
      if (cCount > 100) {
        majorTicks *= 10;
        minorTicks *= 10;
        cCount /= 10;
      }
      else {
        majorTicks *= 5;
        minorTicks *= 5;
        cCount /= 5;
      }
    }
 
    var xUnit = $.trim($("#GetDurationAnalysis_groupBy option:selected").text());
    svgCanvas.graph.noDraw(). 
        addSeries(series, 'lightblue', 'black', 0.5). 
        format('ivory', 'gray'). 
        gridlines({stroke: 'gray', strokeDashArray: '2,2'}, 'gray'); 
    svgCanvas.graph.xAxis.title(xUnit).scale(0, 3). 
        ticks(1, 0).labels(axisLabels); 
    svgCanvas.graph.yAxis.title('Count').ticks(majorTicks, minorTicks).scale(0, maximumCount); 
    svgCanvas.graph.legend.show(false);

    svgCanvas.graph.noDraw(). 
        series(0).format('lightblue').end(). 
        area(0.05, 0.03, 0.99, 0.95).
        redraw();
   
    $("g .series0 rect").each(function () {
      var index = $(this).index();
      $(this).attr("title", xUnit + " " + labels[index] + "=" + series[index]);
    });
   
    $("g .series0 rect").hover(function () {
      var timespan = labels[$(this).index()];
      if (selectedTimespans.indexOf(timespan) == -1) {
        $(this).attr("stroke", "red")
               .attr("stroke-width", 3);
      }
    }, function () {
      var timespan = labels[$(this).index()];
      if (selectedTimespans.indexOf(timespan) == -1) {
        $(this).attr("stroke", "black")
               .attr("stroke-width", 0.5);
      }
    });
    
    $("g .series0 rect").click(function () {
      var timespan = labels[$(this).index()];
      var index = selectedTimespans.indexOf(timespan);
      if (index == -1) {
        selectedTimespans[selectedTimespans.length] = timespan;
        $(this).attr("stroke", "blue")
               .attr("stroke-width", 3);
      }
      else {
        selectedTimespans.splice(index, 1);
        $(this).attr("stroke", "red")
               .attr("stroke-width", 3);
      }
    });
  }

  function OnGetDurationAnalysis_ShowCases()
  {
    OnStartOperation("ShowCases");
    Authenticate(function (sessionId) {
      SetOperationState("Processing query...");
      analysisDrilledDown = true;
      document.parameters.ViewId.value = document.parameters.ViewId.value;

      var selectedTimespansStr = "";

      $.each(selectedTimespans, function (id, timeslot) {
        if (selectedTimespansStr.length > 0)
          selectedTimespansStr += ",";
        selectedTimespansStr += timeslot;
      });

      var options = [ 
        { "Key" : "DrilldownSelection", "Value" : "true" },
        { "Key" : "Granularity", "Value" : document.parameters.GetDurationAnalysis_groupBy.value },
        { "Key" : "DurationTimeSlots", "Value" : selectedTimespansStr },
        { "Key" : "AnalysisType", "Value" : 5 }
      ];

      if (document.parameters.GetDurationAnalysis_useDurationLimit.checked)
        options[options.length] = { "Key" : "MaximumDuration",       "Value" : parseInt(document.parameters.GetDurationAnalysis_durationLimit.value) };

      _client.GetAnalysis(
        sessionId,
        parseInt(document.parameters.ViewId.value), 
        CopyObjectSelectionTo(selectionForDurationAnalysis, options),
        function (result) {
          $("#GetAnalysis_generatedAnalysisType").val("Cases");
          $("#GetAnalysis_result").hide();
          CopySimpleDataTableResultToTable(result, $("#GetAnalysis_resultTable"));
          $("#GetAnalysis_hideSelected, #GetAnalysis_drilldownSelected, #GetAnalysis_selectAll, #GetAnalysis_deselectAll").show();
          $("#GetAnalysis_resultDiv").show();
          ShowPage("GetAnalysis");
          LogOff(OnEndOperation);
        }, OnRequestError);
    });
  }

  function OnGetDurationAnalysis_clearSelection()
  {
    selectionForDurationAnalysis = null;
    $("#GetDurationAnalysis_clearSelection").hide();
    OnGetDurationAnalysis();
  }
  
  function IsOfClass(obj, className)
  {
     return !!(obj.__type.substring(0, className.length + 1) === className + ":");
  }
  
  function ColorToSvgColor(colorValue)
  {
    return "rgb(" + (parseInt(colorValue / (256 * 256)) & 0xff) + "," + (parseInt(colorValue / 256) & 0xff) + "," + (colorValue & 0xff) + ")";
  }

  function GetOpacity(colorValue)
  {
    return parseFloat(parseInt(colorValue / (256 * 256 * 256)) & 0xff) / 255;
  }

  function sHTMLEncode(vsString)
  {
    return $('<div/>').text(vsString).html();
  }

  function sHTMLDecode(vsString)
  {
    return $('<div/>').html(vsString).text();
  }
  
  var arrows = [];
  var selectedActivities = [];
  var selectedTransitions = [];

  function DrawTextBox(svgCanvas, parent, textBox)
  {
    var foregroundColor = ColorToSvgColor(textBox.ForegroundColor.value);
    var rectangle = textBox.Rectangle;
    var rect;
    if (textBox.BackgroundColor.state != 0)
      rect = svgCanvas.rect(parent, rectangle.x, rectangle.y, rectangle.width, rectangle.height, 
        {fill: ColorToSvgColor(textBox.BackgroundColor.value), stroke: foregroundColor, strokeWidth: textBox.LineWeight});
    
    var anchor;
    var textX;
    switch (textBox.Alignment) {
    case 0:
      anchor = "start";
      textX = rectangle.x + 2;
      break;
    case 1:
      anchor = "middle";
      textX = rectangle.x + (rectangle.width / 2);
      break;
    case 2:
      anchor = "end";
      textX = rectangle.x + rectangle.width - 2;
      break;
    }
    
    var text = svgCanvas.text(parent, textX, rectangle.y + (rectangle.height / 2), sHTMLEncode(textBox.Text), 
      {fontFamily: "Verdana", fill: foregroundColor, textAnchor: anchor, dominantBaseline: "middle" });
    $(text).css("font-size", textBox.FontSize + "px");
    if (rect)
      textBox.SvgObject = rect;
    else
      textBox.SvgObject = text;
  }

  function DrawChildShapes(svgCanvas, parent, shape)
  {    
    for (var i = 0; i < shape.ChildShapes.length; ++i) {
      DrawShape(svgCanvas, parent, shape.ChildShapes[i], 2);
    }
  }

  function DrawActivity(svgCanvas, parent, activity)
  {
    var activityGroup = svgCanvas.group(svgCanvas, "activity_" + activity.Id);
    activity.Rectangle.x += 2;
    activity.Rectangle.y += 2;
    activity.Rectangle.width -= 4;
    activity.Rectangle.height -= 4;
    DrawTextBox(svgCanvas, activityGroup, activity);
    var activityRect = activity.SvgObject;

    DrawChildShapes(svgCanvas, activityGroup, activity);

    $(activityGroup).children().andSelf().hover(
      function () {
        if (selectedActivities.indexOf(activity) == -1)
          $(activityRect)
            .attr("stroke", "red")
            .attr("stroke-width", 3);
      },
      function () {
        if (selectedActivities.indexOf(activity) == -1)
          $(activityRect)
            .attr("stroke", ColorToSvgColor(activity.ForegroundColor.value))
            .attr("stroke-width", activity.LineWeight);
      }
    );
    
    $(activityGroup).click(function () {
      var index = selectedActivities.indexOf(activity);
      if (index == -1) {
        $(activityRect)
              .attr("stroke", "blue")
              .attr("stroke-width", 3);
        selectedActivities.push(activity);
      }
      else {
        $(activityRect)
          .attr("stroke", "red")
          .attr("stroke-width", 3);
        selectedActivities.splice(index, 1);
      }
    });
    
    return activityGroup;
  }
  
  var svgDefsSection;
  
  function GetOrCreateArrowMarkerId(svgCanvas, colorValue, useGivenColor)
  {
    var markerId = arrows["arrow_" + colorValue];
    if (!markerId) {
      markerId = "arrow_" + colorValue;
      var arrowMarker = svgCanvas.marker(svgDefsSection, markerId, 7, 5, 4, 3, {viewBox: "0 0 10 10"});
      svgCanvas.polyline(arrowMarker, [[0,0],[10,5],[0,10],[1,5]], { fill: useGivenColor ? colorValue : ColorToSvgColor(colorValue), strokeWidth : 0 });
      arrows[markerId] = markerId;
    }
    return markerId;
  }
  
  function InitializeConnectorEvents(svgCanvas, svgGroup, svgConnector, svgTextBox, connector, foregroundColor)
  {
    connector.SvgObject = svgGroup;
    connector.SvgTextColor = $(svgTextBox).attr("fill");

    $(svgGroup).children().andSelf().hover(
      function () {
        if (selectedTransitions.indexOf(connector) == -1) {
          var markerId = GetOrCreateArrowMarkerId(svgCanvas, "red", true);
          $(svgConnector)
            .attr("stroke", "red")
            .attr("marker-end", "url(#" + markerId + ")");
          $(svgTextBox)
            .attr("fill", "red");
        }
      },
      function () {
        if (selectedTransitions.indexOf(connector) == -1) {
          var markerId = GetOrCreateArrowMarkerId(svgCanvas, connector.ForegroundColor.value);        
          $(svgConnector)
            .attr("stroke", foregroundColor)
            .attr("marker-end", "url(#" + markerId + ")");
          $(svgTextBox)
            .attr("fill", connector.SvgTextColor);
        }
      }
    )
    $(svgGroup).click(function () {
      var index = selectedTransitions.indexOf(connector);
      if (index == -1) {
        var markerId = GetOrCreateArrowMarkerId(svgCanvas, "blue", true);
        $(svgConnector)
              .attr("stroke", "blue")
              .attr("stroke-width", connector.LineWeight + 3)
              .attr("marker-end", "url(#" + markerId + ")");
        $(svgTextBox)
              .attr("fill", "blue");
        selectedTransitions.push(connector);
      }
      else {
        var markerId = GetOrCreateArrowMarkerId(svgCanvas, "red", true);
        $(svgConnector)
          .attr("stroke", "red")
          .attr("stroke-width", connector.LineWeight)
          .attr("marker-end", "url(#" + markerId + ")");
        $(svgTextBox)
              .attr("fill", "red");
        selectedTransitions.splice(index, 1);
      }
    });
  }
  
  function DrawStraightConnector(svgCanvas, parent, connector)
  {
    var connectorGroup = svgCanvas.group(parent, "connector_" + connector.FromId + "_" + connector.ToId);

    var foregroundColor = ColorToSvgColor(connector.ForegroundColor.value);
    var markerId = GetOrCreateArrowMarkerId(svgCanvas, connector.ForegroundColor.value);

    var line = svgCanvas.line(connectorGroup, connector.From.x, connector.From.y, connector.To.x, connector.To.y, 
      { stroke: foregroundColor, fill: foregroundColor, strokeWidth: connector.LineWeight, markerEnd: "url(#" + markerId + ")",
        opacity: GetOpacity(connector.ForegroundColor.value)
      });

    DrawChildShapes(svgCanvas, connectorGroup, connector);

    InitializeConnectorEvents(svgCanvas, connectorGroup, line, connector.ChildShapes[0].SvgObject, connector, foregroundColor);
  }

  function DrawCurvedConnector(svgCanvas, parent, connector)
  {
    var connectorGroup = svgCanvas.group(parent, "connector_" + connector.FromId + "_" + connector.ToId);

    var foregroundColor = ColorToSvgColor(connector.ForegroundColor.value);
    var markerId = GetOrCreateArrowMarkerId(svgCanvas, connector.ForegroundColor.value);

    var path = svgCanvas.createPath();
    var points = connector.Points;
    path.move(points[0].x, points[0].y);
    var curveArray = [];
    var i = 1;
    while (i + 3 <= points.length)
    {
      curveArray.push([points[i].x, points[i].y, points[i + 1].x, points[i + 1].y, points[i + 2].x, points[i + 2].y]);
      i += 3;
    }
    path.curveC(curveArray);

    var path = svgCanvas.path(connectorGroup, path, 
      { stroke: foregroundColor, fill: "none", strokeWidth: connector.LineWeight, markerEnd: "url(#" + markerId + ")",
        opacity: GetOpacity(connector.ForegroundColor.value)
      });
      
    DrawChildShapes(svgCanvas, connectorGroup, connector);

    InitializeConnectorEvents(svgCanvas, connectorGroup, path, connector.ChildShapes[0].SvgObject, connector, foregroundColor);
  }

  function DrawShape(svgCanvas, parent, shape, pass)
  {
    if (pass == 0) {
      if (IsOfClass(shape, "StraightConnector") || IsOfClass(shape, "CurvedConnector")) {
        GetOrCreateArrowMarkerId(svgCanvas, shape.ForegroundColor.value);
      }
    }
    else if (pass == 1) {
      if (IsOfClass(shape, "ActivityBox"))
        DrawActivity(svgCanvas, parent, shape);
    }
    else {
      if (IsOfClass(shape, "TextBox"))
        DrawTextBox(svgCanvas, parent, shape);
      else if (IsOfClass(shape, "StraightConnector"))
        DrawStraightConnector(svgCanvas, parent, shape);
      else if (IsOfClass(shape, "CurvedConnector"))
        DrawCurvedConnector(svgCanvas, parent, shape);
    }
  }
  
  function DrawLayoutAsSvg(layout, svgCanvas)
  {
//		$(surface).mousedown(startDrag).mousemove(dragging).mouseup(endDrag);
//		resetSize(svgCanvas, '100%', '100%');
//    svgCanvas.clientWidth = (extents.x + extents.width);
//    svgCanvas.clientHeight = (extents.y + extents.height);

//    var surface = svgCanvas.rect(0, 0, '100%', '100%', {id: 'surface', fill: 'white'});

    var surface = svgCanvas;
    svgDefsSection = svgCanvas.defs("Definitions");

    for (var i = 0; i < layout.Shapes.length; ++i) {
      DrawShape(svgCanvas, surface, layout.Shapes[i], 0);
    }
    // Kludge to avoid missing marker ends-issue in FF
    setTimeout(function() {
      for (var pass = 1; pass < 3; ++pass) {
        for (var i = 0; i < layout.Shapes.length; ++i) {
          DrawShape(svgCanvas, surface, layout.Shapes[i], pass);
        }
      }
    }, 1);
  }

  function ApplyAnalysisFilters(filterType, callbackFunc)
  {
    OnStartOperation("ApplyFilters");
    Authenticate(function (sessionId) { OnApplyAnalysisFiltersAuthenticationFinished(sessionId, filterType, callbackFunc); });
  }

  function GetObjectSelection()
  {
    var selectedActivityIds = [];
    var selectedTransitionIds = [];

    $.each(selectedActivities, function (id, activity) {
      selectedActivityIds.push(activity.Id);
    });

    $.each(selectedTransitions, function (id, transition) {
      selectedTransitionIds.push([transition.FromId, transition.ToId]);
    });

    return { 
      "Activities" : selectedActivityIds,
      "Transitions" : selectedTransitionIds
    };
  }
  
  function GetViewProperties(properties)
  {
    var result = properties ? properties : [];
    var page = GetPageById(_selectedPage);
    if (typeof(page.GetViewType) !== "undefined")
      result[result.length] = { "Key" : "ViewType", "Value" : page.GetViewType() };
    return result;
  }
  
  function GetAnalysisPropertiesForFiltering()
  {
    var result = GetViewProperties();
    var selectedAttributeValueCategories = document.parameters.GetProfilingAnalysis_attribute.value;
    $("#GetProfilingAnalysis_resultTable input.SelectedCheckbox:checked").each(function () {
      var parts = $(this).attr("id").match(/selectedCheckbox_(.*)/i);
      if (parts) {
        if (selectedAttributeValueCategories.length > 0)
          selectedAttributeValueCategories += ",";
        selectedAttributeValueCategories += parts[1];
      }
    });
    result[result.length] = { "Key" : "SelectedAttributeValueCategories", "Value" : selectedAttributeValueCategories };
    
    var selectedDurationTimeSlots = "";
    $.each(selectedTimespans, function (id, timeslot) {
      if (selectedDurationTimeSlots.length > 0)
        selectedDurationTimeSlots += ",";
      selectedDurationTimeSlots += timeslot;
    });
    
    result[result.length] = { "Key" : "DurationTimeSlots", "Value" : selectedDurationTimeSlots };
    if (document.parameters.GetDurationAnalysis_useDurationLimit.checked)
      result[result.length] = { "Key" : "MaximumDuration", "Value" : parseInt(document.parameters.GetDurationAnalysis_durationLimit.value) };

    return CopyObjectSelectionTo(GetObjectSelection(), result)
  }

  function OnApplyAnalysisFiltersAuthenticationFinished(sessionId, filterType, callbackFunc)
  {
    SetOperationState("Processing query...");

    _client.ApplyAnalysisFilters(
      sessionId,
      parseInt(document.parameters.ViewId.value), 
      filterType,
      GetAnalysisPropertiesForFiltering(),
      function (result) {
        document.parameters.ViewId.value = result;
        callbackFunc(_sessionId);
        OnViewIdInputChanged();
      }, OnRequestError);
  }
  
  function OnGetProcessAnalysis_ShowCases()
  {
    OnStartOperation("ShowCases");
    Authenticate(function (sessionId) {
      SetOperationState("Processing query...");
      analysisDrilledDown = true;

      _client.GetAnalysis(
        sessionId,
        parseInt(document.parameters.ViewId.value), 
        CopyObjectSelectionTo(GetObjectSelection(), [ { "Key" : "DrilldownSelection", "Value" : "true" }, { "Key" : "AnalysisType", "Value" : 5 } ]),
        function (result) {
          $("#GetAnalysis_generatedAnalysisType").val("Cases");
          $("#GetAnalysis_result").hide();
          CopySimpleDataTableResultToTable(result, $("#GetAnalysis_resultTable"));
          $("#GetAnalysis_hideSelected, #GetAnalysis_drilldownSelected, #GetAnalysis_selectAll, #GetAnalysis_deselectAll").show();
          $("#GetAnalysis_resultDiv").show();
          ShowPage("GetAnalysis");
          LogOff(OnEndOperation);
        }, OnRequestError);
    });
  }
  
  function OnGetProcessAnalysis_ExcludeSelected()
  {
    ApplyAnalysisFilters(0, OnGetProcessAnalysisAuthenticationFinished);
  }
  
  function OnGetProcessAnalysis_IncludeOnlySelected()
  {
    ApplyAnalysisFilters(1, OnGetProcessAnalysisAuthenticationFinished);
  }

  function OnGetProcessAnalysis_DurationAnalysis()
  {
    selectionForDurationAnalysis = GetObjectSelection();
    OnGetDurationAnalysis();
  }
  
  function OnGetProcessAnalysisAsImage()
  {
    OnStartOperation("GetProcessAnalysisAsImage");
    Authenticate(function (sessionId) {
      SetOperationState("Processing query...");

      var url = GetMethodURL("GetAnalysisAsImage", { 
        sessionId : sessionId, 
        viewId : parseInt(document.parameters.ViewId.value), 
        analysisType : 0,
        processAnalysisType : parseInt(document.parameters.GetProcessAnalysis_analysisType.value),
        minTransitionPercentage : parseFloat(document.parameters.GetProcessAnalysis_minFlowVolume.value) / 100
      });

      var resultImage = document.getElementById("GetProcessAnalysis_resultImage");
      resultImage.src = url;
      $("#GetProcessAnalysis_result").hide();
      $("#GetProcessAnalysis_resultSvgDiv").hide();
      $("#GetProcessAnalysis_drilldownButtonsDiv").hide();
      $("#GetProcessAnalysis_resultDiv").show();
      $("#GetProcessAnalysis_resultImage").show();
    });
  }

  function OnLoadedGetProcessAnalysisAsImage_resultImage()
  {
    LogOff(OnEndOperation);
  }

  function OnGetModelAsStream(modelId, viewId)
  {
    OnStartOperation("GetModelAsStream");
    Authenticate(function (sessionId) {
      SetOperationState("Processing query...");

      var url = GetMethodURL("GetModelAsStream", { 
        "sessionId" : sessionId, 
        "viewId" : modelId ? modelId : viewId, 
        "parameters" : modelId ? [{ "Key" : "ViewIdIsModelId", "Value" : "true"}] : []
      });
      
      var resultFrame = document.getElementById("GetModelAsStream_resultFrame");
      resultFrame.src = url;

      window.setTimeout(function () { LogOff(OnEndOperation); }, 10);
    });
  }

  var _GetProfilingAnalysis_attributesRetrievedForViewId = 0;
  
  function GetProfilingAnalysis_OnShowPage()
  {
    var viewId = parseInt($.trim(document.parameters.ViewId.value));
    if (_GetProfilingAnalysis_attributesRetrievedForViewId == viewId)
      return;
    OnStartOperation("Get attribute types");
    Authenticate(function (sessionId) {
      SetOperationState("Processing query...");

      _client.GetAttributeTypes(
        sessionId,
        viewId, 
        [],
        function (result) {
          _GetProfilingAnalysis_attributesRetrievedForViewId = viewId;
          var selectedAttribute = document.parameters.GetProfilingAnalysis_attribute.value;

          var selectRoot = $("#GetProfilingAnalysis_attribute");
          selectRoot.children().remove();

          if (result && (result.length > 0)) {
            $.each(result, function (id, attributeType) {	
              if (attributeType.Type == 3) {
                var option = $("<option></option>")
                  .val(attributeType.Id)
                  .text(attributeType.Name);
                if (selectedAttribute == attributeType.Id)
                  option.attr("selected", "selected");
                selectRoot.append(option);
              }
            });
          }

          if (!result || (result.length == 0))
            $("#GetProfilingAnalysis").hide();
          else
            $("#GetProfilingAnalysis").show();
          
          LogOff(OnEndOperation);
        }, OnRequestError);
    });
  }
 
  function OnGetProfilingAnalysis()
  {
    OnStartOperation("OnGetProfilingAnalysis");
    Authenticate(OnGetProfilingAnalysisAuthenticationFinished);
  }

  function OnGetProfilingAnalysisAuthenticationFinished(sessionId)
  {
    SetOperationState("Processing query...");

    var options = [ { "Key" : "SelectedAttributeType",       "Value" : document.parameters.GetProfilingAnalysis_attribute.value },
        { "Key": "AnalysisType", "Value": 10 },
        { "Key": "ForceAnalysisResultType", "Value": 1 } ];
      
    _client.GetAnalysis(
      sessionId,
      parseInt(document.parameters.ViewId.value), 
      options,
      function (result) {
        $("#GetProfilingAnalysis_resultDiv").show();
        $("#GetProfilingAnalysis_drilldownButtonsDiv").show();

        CopyObjectListToTable("Attribute Value Categories", "Models", result.Categories, $("#GetProfilingAnalysis_resultTable"), [
            {
              "First":true,
              "Caption":"Select", 
              "Generator":function (id, parentElement) {
                var checkbox = $("<input type=\"checkbox\" />").attr("id", "selectedCheckbox_" + id).addClass("SelectedCheckbox");
                checkbox.appendTo(parentElement);
              }
            }
          ], ["Count", "Value"]);

        var resultSvgDiv = $("#GetProfilingAnalysis_resultSvgDiv");
        resultSvgDiv.svg("destroy");

        if (result.Categories.length > 1) {
          resultSvgDiv.show();
          resultSvgDiv.css("width", "640px").css("height", "480px");
          resultSvgDiv.svg(function (svgCanvas) { DrawProfilingAnalysisAsSvg(result, svgCanvas); });
        }
        else {
          resultSvgDiv.hide();
        }

        LogOff(OnEndOperation);
      }, OnRequestError);
  }
  
  function DrawProfilingAnalysisAsSvg(result, svgCanvas)
  {
    var MAXIMUM_NUMBER_OF_SERIESES = 30;

    var colors = [
      "rgb( 69, 114, 167)",
      "rgb(170,  70,  67)",
      "rgb(137, 165,  78)",
      "rgb(113,  88, 143)",
      "rgb( 65, 152, 175)",
      "rgb(219, 132,  61)",
      "rgb(147, 169, 207)",
      "rgb(209, 147, 146)",
      "rgb(185, 205, 150)",
      "rgb(169, 155, 189)",
      "rgb(145, 195, 213)"
    ];
    svgCanvas.graph.noDraw()
      .format('ivory', 'gray');

    var totalCount = 0;
    $.each(result.Categories, function (id, category) {
      totalCount += category.Count;
    });

    var countThusFar = 0;
    $.each(result.Categories, function (id, category) {
      if (id < MAXIMUM_NUMBER_OF_SERIESES) {
        var origLabel = "" + category.Value;
        var label = origLabel.substring(0, 22) + (origLabel.length > 22 ? "..." : "");
        svgCanvas.graph.addSeries(label, [category.Count], colors[id % colors.length], "none");
      }
      else if (id == MAXIMUM_NUMBER_OF_SERIESES) {
        svgCanvas.graph.addSeries("<Others>", [totalCount - countThusFar], colors[id % colors.length], "none");
      }
      countThusFar += category.Count;
    });

    svgCanvas.graph.xAxis.title('', 'green').labels(['']);
    svgCanvas.graph.legend.settings({fill: 'lightgoldenrodyellow', stroke: 'gray'});

    svgCanvas.graph.noDraw().
      legend.show(1).area([0.01, 0.01, 0.3, 0.99]).end().
      area(0.31, 0.01, 0.99, 0.99).
//      type("pie", {explode: 2, explodeDist: 10})
      type("pie")
      .redraw();
  }

  function OnImportModel()
  {
    OnStartOperation("ImportModel");
    Authenticate(OnImportModelAuthenticationFinished);
  }

  function OnImportModelAuthenticationFinished(sessionId)
  {
    SetOperationState('Importing  model...');

    var form = $('#importForm');

    form.ajaxForm({
      iframe:   true,
      dataType: 'xml',
      success:  OnImportModelCheckReturnValue,
      timeout:  10000, // 10 seconds, very conservative
      complete: OnImportModelError,
      url:      GetMethodURL('WebImportModel', '')
                + '?sessionId=' + encodeURIComponent(sessionId)
                + '&modelName=' + encodeURIComponent(document.importParameters.ImportModel_modelName.value)
    });

    form.submit();

    _buttonsDisabledByOperation = _buttonsDisabledByOperation.add($('#ImportModel_start'));
    _buttonsDisabledByOperation.attr("disabled", "disabled");
  }

  function OnImportModelCheckReturnValue(data)
  {
    var resultNode = $(data).find('long');
    if (!resultNode || resultNode.length < 1) {
      // It appears we got an altogether invalid response.
      OnRequestError({ get_message: function() { return "No result returned from server"; } });
    } else {
      var response = resultNode.text();
      if (response == '0')
        OnRequestError({ get_message: function() { return response; } });
    }
    LogOff(OnEndOperation);
  }

  function OnImportModelError(data, status)
  {
    SetPasswordBoxType('password');

    if (status == 'error') {
      // This actually happens when the timeout is triggered, which, in turn,
      // happens probably when WCF doesn't accept the file because it's too big
      OnRequestError({ get_message: function() {
          return "No result returned from server.\r\n" +
                 "It's possible that the file was too big.\r\n" +
                 "Check your Web.config's maxReceivedMessageSize setting";
        } });
      LogOff(OnEndOperation);
    }
  }

  function OnGetOperationStatus()
  {
    OnStartOperation("OnGetOperationStatus");
    Authenticate(OnGetOperationStatusAuthenticationFinished)
}

  function OnGetOperationStatusAuthenticationFinished()
  {
    SetOperationState("Processing query...");
    var scope = $('input:radio[name="OperationStatus_queryScope"]:checked').val();
    var parameters = [];
    switch (scope) {
      case "0":
        parameters[parameters.length] = { "Key": "ShowOpenOnly", "Value": true };
        break;
      case "1":
        parameters[parameters.length] = { "Key" : "MaximumCount", "Value" : 1000 };
        break;
      case "2":
        parameters[parameters.length] = { "Key" : "All", "Value" : true };
        break;
    }

    _client.GetOperationStatuses(
      _sessionId,
      parameters,
      function (result) 
      {
        var extraColumns = scope != "0" ? [] : [
          {
            "First":false,
            "Caption":"Cancel", 
            "Generator":function (id, parentElement) {
              var button = $("<input type=\"button\" id=\"cancelButton_" + id + "\" value=\"Cancel\" />").click(function () {
                var id = $(this).attr("id");
                CancelOperation(id.split("_")[1]);
              });
              button.appendTo(parentElement);
            }
          }
        ];

        CopyObjectListToTable("Operation Statuses", "Default", result, $("#OperationStatus_resultTable"), extraColumns, 
          scope == "0" ?
            ["Id", "UserId", "UserName", "SessionId", "ViewId", "ModelId", "ModelName", "Name", "StartTime", "Duration", "Value", "MaximumValue", "AdditionalData", "Message"] :
            ["Id", "UserId", "UserName", "SessionId", "ViewId", "ModelId", "ModelName", "Name", "StartTime", "EndTime", "Duration", "Value", "MaximumValue", "AdditionalData", "Message"]);
        $("#OperationStatus_resultDiv").show();

        LogOff(OnEndOperation);
      }, OnRequestError);
  }

  function CancelOperation(operationId)
  {
    OnStartOperation("CancelOperation");
    Authenticate(function () {
      SetOperationState("Cancelling operation...");

      _client.CancelOperation(
        _sessionId,
        operationId,
        [],
        function (result) {
          OnGetOperationStatusAuthenticationFinished();
        }, OnRequestError);
    });
  }

  function OnCancelOperation()
  {
    if (!_sessionId)
      return;
    _cancelOperationClient.CancelOperation(
        _sessionId,
        0,
        [],
        function (result) {
    }, OnRequestError);
  }

  function GetEndpointUrlSuffix() 
  {
    return document.location.protocol == "https:" ? "/secureWebHttp" : "/webHttp";
  }

  function OnLoad()
  {
    $('input').filter(':disabled').removeAttr("disabled");

    var sURL = document.location.href;
    ShowPage(_selectedPage, true);
    try {
      _client = new www.qpr.com.ns.IService();
      _cancelOperationClient = new www.qpr.com.ns.IService();
    }
    catch (e) {
      var message = JSON.stringify(e, null, '\t');
      alert("Error initializing main service connection. Redirecting to main service page.\r\nException:\r\n" + message);
      document.location = "MainService.svc";
    }

    _client.set_path(sURL.substring(0, sURL.lastIndexOf('/')) + "/MainService.svc" + GetEndpointUrlSuffix());
  }
-->
</script>
</head>
<body onload="OnLoad()">
  <form id="ScriptForm" runat="server" action="#">
    <asp:scriptmanager id="scrptMgr" runat="server" >
    </asp:scriptmanager>
<script type="text/javascript">
<!--
//      <services>
//        <asp:servicereference path="~/MainService.svc/webHttp" />
//        <asp:servicereference path="~/MainService.svc/secureWebHttp" />
//      </services>
  document.write('<script src="MainService.svc' + GetEndpointUrlSuffix() + '/js"></scr' + 'ipt>');
-->
</script>
  </form>
  <div class="MainHeader">
    <div id="pageSelector">
    </div>
  </div>

  <div class="MainBody">
    <form name="Authentication_form" style="width:100%;" action="#" method="POST" enctype="multipart/form-data" accept-charset="UTF-8" id="authenticationForm">
      <div id="Authentication_Parameters" class="Page" style="display: none;">
        <table style="width:100%;">
          <tr>
            <th style="white-space:nowrap;">
              Logon name:
            </th>
            <td style="width:100%;"> 
              <input type="text" name="Authentication_logonName" value="" style="width:100%;" />
            </td>
          </tr>
          <tr>
            <th style="white-space:nowrap;">
              Password:
            </th>
            <td style="width:100%;"> 
              <input type="password" name="Authentication_password" value="" style="width:100%;" />
            </td>
          </tr>
        </table>
        <input type="submit" value="Log On" id="logOnButton" onclick="javascript:OnLogOn(); return false;" />
      </div>
    </form>

    <form name="parameters" style="width:100%;" action="#" method="POST" enctype="multipart/form-data" accept-charset="UTF-8" id="mainForm">
      <div id="ViewId_Parameters" class="PageHeader" style="display: none;">
        <table style="width:100%;">
          <tr>
            <th style="white-space:nowrap; vertical-align:top;">
              View id:
            </th>
            <td style="width:100%;"> 
              <input type="text" name="ViewId" value="1" style="width:100%;" onchange="OnViewIdInputChanged()"/>
            </td>
          </tr>
        </table>
      </div>

      <div id="GetModels_Parameters" class="Page, PageHeader" style="display: none;">
        <table style="width:100%;">
        </table>
        <input type="button" name="Ok" value="Refresh" onclick="javascript:OnGetModels()" />
        <input type="button" name="Ok" value="Import Model" onclick="javascript:OnOpenImportModelView()" />
        <hr/>
  <!--
        <textarea id="GetModels_result" rows="25" cols="80" style="width:100%; height:500px;"></textarea>
  -->
        <div id="GetModels_resultDiv" style="display:none;">
          <table id="GetModels_resultTable" class="MethodResult" style="width:100%;" cellpadding="0" cellspacing="0"></table>
          <iframe id="GetModelAsStream_resultFrame" src="#" style="display:none"></iframe>
        </div>
      </div>

      <div id="GetAnalysis_Parameters" class="Page" style="display: none;">
        <table style="width:100%;">
          <tr>
            <th style="white-space:nowrap;">
              List type:
            </th>
            <td style="width:100%;"> 
              <select id="GetAnalysis_analysisType" name="GetAnalysis_analysisType" size="1">
                <option value="5" selected="selected" id="AnalysisType_5">
                  Cases
                </option>
                <option value="7" id="AnalysisType_7">
                  Activities
                </option>
                <option value="8" id="AnalysisType_8">
                  Variations
                </option>
              </select>
            </td>
          </tr>
        </table>
        <input type="button" name="GetAnalysis" value="Get Objects" onclick="javascript:OnGetAnalysis()" />
        <hr/>
        <div id="GetAnalysis_resultDiv" style="display:none;">
          <input type="button" id="GetAnalysis_selectAll" name="GetAnalysis_selectAll" value="Select All" onclick="javascript:OnSelectAll()" />
          <input type="button" id="GetAnalysis_deselectAll" name="GetAnalysis_deselectAll" value="Deselect All" onclick="javascript:OnDeselectAll()" />
          <input type="button" id="GetAnalysis_hideSelected" name="GetAnalysis_hideSelected" value="Hide Selected" onclick="javascript:OnHideSelected()" />
          <input type="button" id="GetAnalysis_drilldownSelected" name="GetAnalysis_drilldownSelected" value="Drilldown Selected" onclick="javascript:OnDrilldownSelected()" />
          <table id="GetAnalysis_resultTable" class="MethodResult" style="width:100%;" cellpadding="0" cellspacing="0"></table>
          <input type="hidden" id="GetAnalysis_generatedAnalysisType" name="GetAnalysis_generatedAnalysisType" />
        </div>
      </div>

      <div id="GetProcessAnalysis_Parameters" class="Page" style="display: none;">
        <table style="width:100%;">
          <tr style="display: none">
            <th style="white-space:nowrap;">
              Analysis type:
            </th>
            <td style="width:100%;"> 
              <select name="GetProcessAnalysis_analysisType" size="1">
                <option value="4" selected="selected">
                  Forward
                </option>
                <option value="2">
                  Boxed
                </option>
              </select>
            </td>
          </tr>
          <tr>
            <th style="white-space:nowrap;">
              Minimum flow volume:
            </th>
            <td style="width:100%;"> 
              <input type="text" name="GetProcessAnalysis_minFlowVolume" value="5" style="width:100%;" />
            </td>
          </tr>
          <tr>
            <th style="white-space:nowrap;">
              Transition type:
            </th>
            <td style="width:100%;"> 
              <select name="GetProcessAnalysis_transitionType" size="1">
                <option value="0" selected="selected">
                  Unique Only
                </option>
                <option value="1">
                  All Occurrences
                </option>
              </select>
            </td>
          </tr>
          <tr>
            <th style="white-space:nowrap;">
              Use median:
            </th>
            <td style="width:100%;"> 
              <input type="checkbox" id="GetProcessAnalysis_useMedians" name="GetProcessAnalysis_useMedians" />
            </td>
          </tr>
          <tr style="display: none">
            <th style="white-space:nowrap;">
              Include statistics data:
            </th>
            <td style="width:100%;"> 
              <input type="checkbox" name="GetProcessAnalysis_includeStatistics" />
            </td>
          </tr>
          <tr style="display: none">
            <th style="white-space:nowrap;">
              Include layout data:
            </th>
            <td style="width:100%;"> 
              <input type="checkbox" name="GetProcessAnalysis_includeLayout" checked="checked" />
            </td>
          </tr>
        </table>
        <input type="button" name="GetProcessAnalysis" value="Process Analysis" onclick="javascript:OnGetProcessAnalysis()" />
        <input type="button" name="GetProcessAnalysis" value="Process Analysis as PNG Image" onclick="javascript:OnGetProcessAnalysisAsImage()" />
        <hr/>
        <div id="GetProcessAnalysis_resultDiv" style="display: none">
          <div id="GetProcessAnalysis_drilldownButtonsDiv" style="display: none">
            <input type="button" name="GetProcessAnalysis_ShowCases" value="Show Cases" onclick="javascript:OnGetProcessAnalysis_ShowCases()" />
            <input type="button" name="GetProcessAnalysis_ExcludeSelectedActivities" value="Exclude Selected" onclick="javascript:OnGetProcessAnalysis_ExcludeSelected()" />
            <input type="button" name="GetProcessAnalysis_IncludeOnlySelectedActivities" value="Include Only Selected" onclick="javascript:OnGetProcessAnalysis_IncludeOnlySelected()" />
            <input type="button" name="GetProcessAnalysis_ClearFilters" value="Clear Filters" onclick="javascript:OnClearFilters()" />
            <input type="button" name="GetProcessAnalysis_DurationAnalysis" value="Duration Analysis" onclick="javascript:OnGetProcessAnalysis_DurationAnalysis()" />
          </div>
          <div id="GetProcessAnalysis_resultSvgDiv"></div>
          <textarea id="GetProcessAnalysis_result" rows="10" cols="80" style="width:100%; height:200px; display: none;"></textarea>
          <img id="GetProcessAnalysis_resultImage" src="#" style="display: none;" alt="GetProcessAnalysisAsImage result image" onload="OnLoadedGetProcessAnalysisAsImage_resultImage()" />
        </div>
      </div>

      <div id="GetDurationAnalysis_Parameters" class="Page" style="display: none;">
        <table style="width:100%;">
          <tr>
            <th style="white-space:nowrap;">
              Group by:
            </th>
            <td style="width:100%;"> 
              <select id="GetDurationAnalysis_groupBy" name="GetDurationAnalysis_groupBy" size="1">
                <option value="1">
                  Second
                </option>
                <option value="60">
                  Minute
                </option>
                <option value="3600">
                  Hour
                </option>
                <option value="86400" selected="selected">
                  Day
                </option>
                <option value="2592000">
                  Month
                </option>
              </select>
            </td>
          </tr>
          <tr>
            <th style="white-space:nowrap;">
              Use duration limit:
            </th>
            <td style="width:100%;"> 
              <input type="checkbox" id="GetDurationAnalysis_useDurationLimit" name="GetDurationAnalysis_useDurationLimit" onChange="OnGetDurationAnalysis_useDurationLimitChanged()"/>
              <input type="text" id="GetDurationAnalysis_durationLimit" name="GetDurationAnalysis_durationLimit" value="100" style="width:100px;" disabled="disabled" />
            </td>
          </tr>
        </table>
        <input type="button" name="GetDurationAnalysis" value="Duration Analysis" onclick="javascript:OnGetDurationAnalysis()" />
        <hr/>
        <div id="GetDurationAnalysis_resultDiv" style="display: none">
          <div id="GetDurationAnalysis_drilldownButtonsDiv" style="display: none">
            <input type="button" name="GetDurationAnalysis_showCases" value="Show Cases" onclick="javascript:OnGetDurationAnalysis_ShowCases()" />
            <input type="button" id="GetDurationAnalysis_clearSelection" name="GetDurationAnalysis_clearSelection" value="Clear Selection" onclick="javascript:OnGetDurationAnalysis_clearSelection()" />
            <input type="button" id="GetDurationAnalysis_exclude" name="GetDurationAnalysis_exclude" value="Exclude Selected" onclick="javascript:OnExcludeSelected()" />
            <input type="button" id="GetDurationAnalysis_include" name="GetDurationAnalysis_include" value="Include Only Selected" onclick="javascript:OnIncludeOnlySelected()" />
            <input type="button" name="ClearFilters" value="Clear Filters" onclick="javascript:OnClearFilters()" />
          </div>
          <div id="GetDurationAnalysis_resultSvgDiv"></div>
          <textarea id="GetDurationAnalysis_result" rows="10" cols="80" style="width:100%; height:200px; display: none;"></textarea>
        </div>
      </div>

      <div id="GetProfilingAnalysis_Parameters" class="Page" style="display: none;">
        <table style="width:100%;">
          <tr>
            <th style="white-space:nowrap;">
              Attribute:
            </th>
            <td style="width:100%;"> 
              <select id="GetProfilingAnalysis_attribute" name="GetProfilingAnalysis_attribute" size="1">
              </select>
            </td>
          </tr>
        </table>
        <input type="button" id="GetProfilingAnalysis" name="GetProfilingAnalysis" value="Profiling Analysis" onclick="javascript:OnGetProfilingAnalysis()" style="display: none" />
        <hr/>
        <div id="GetProfilingAnalysis_resultDiv" style="display: none">
          <div id="GetProfilingAnalysis_drilldownButtonsDiv" style="display: none">
            <input type="button" id="GetProfilingAnalysis_selectAll" name="GetProfilingAnalysis_selectAll" value="Select All" onclick="javascript:OnSelectAll()" />
            <input type="button" id="GetProfilingAnalysis_deselectAll" name="GetProfilingAnalysis_deselectAll" value="Deselect All" onclick="javascript:OnDeselectAll()" />
            <input type="button" id="GetProfilingAnalysis_drilldownSelected" name="GetProfilingAnalysis_drilldownSelected" value="Drilldown Selected" onclick="javascript:OnDrilldownSelected()" />
            <input type="button" id="GetProfilingAnalysis_exclude" name="GetProfilingAnalysis_exclude" value="Exclude Selected" onclick="javascript:OnExcludeSelected()" />
            <input type="button" id="GetProfilingAnalysis_include" name="GetProfilingAnalysis_include" value="Include Only Selected" onclick="javascript:OnIncludeOnlySelected()" />
            <input type="button" name="ClearFilters" value="Clear Filters" onclick="javascript:OnClearFilters()" />
          </div>
          
          <div>
            <div style="float: left; width: 40%;">
              <table id="GetProfilingAnalysis_resultTable" class="MethodResult" style="width:100%;" cellpadding="0" cellspacing="0"></table>
            </div>
            <div style="float: left;">
              <div id="GetProfilingAnalysis_resultSvgDiv"></div>
            </div>
          </div>
          <div style="clear: both;"></div>
        </div>
      </div>

      <div id="OperationStatus_Parameters" class="Page" style="display: none;">
        <table style="width:100%;">
          <tr>
            <th style="white-space:nowrap; vertical-align:top;">
              Query Operations:
            </th>
            <td style="width:100%;"> 
              <input type="radio" name="OperationStatus_queryScope" value="0" checked="checked" />Currently processed
              <br />
              <input type="radio" name="OperationStatus_queryScope" value="1" />Top 1000
              <br />
              <input type="radio" name="OperationStatus_queryScope" value="2" />All
            </td>
          </tr>
        </table>
        <input type="button" name="Ok" value="Get Operation Status" onclick="javascript:OnGetOperationStatus()" />
        <hr/>
        <div id="OperationStatus_resultDiv" style="display:none;">
          <table id="OperationStatus_resultTable" class="MethodResult" style="width:100%;" cellpadding="0" cellspacing="0"></table>
        </div>
      </div>
    </form>

    <form id="importForm" name="importParameters" style="width:100%" action="#" method="post" enctype="multipart/form-data" accept-charset="UTF-8">
      <div id="ImportModel_Parameters" class="Page" style="display: none;">
        <table style="width:100%;">
          <tr>
            <th style="white-space:nowrap; vertical-align:top;">
              Model name:
            </th>
            <td style="width:100%;"> 
              <input type="text" id="ImportModel_modelName" name="ImportModel_modelName" value="Model Imported From Web Service" style="width:100%;" />
            </td>
          </tr>
          <tr>
            <th style="white-space:nowrap; vertical-align:top;">
              File:
            </th>
            <td style="width:100%;"> 
              <input type="file" id="ImportModel_file" name="ImportModel_file" style="width:100%;" />
            </td>
          </tr>
        </table>
        <input id="ImportModel_start" type="button" name="Ok" value="Import Model" onclick="javascript:OnImportModel()" />
      </div>
    </form>

    <div class="PageFooter">
      Query state: <span id="OperationState">Idle</span>
      <br />
      <div id="CancelOperationDiv" style="display:none">
        <input type="button" id="CancelButton" value="Cancel" onclick="javascript:OnCancelOperation()" />
      </div>
      <span id="ElapsedTime"></span> 
    </div>
  </div>
  <div class="MainFooter">
    <div style="float: left;">
      ProcessAnalyzer Web Client
<%
  var version = typeof(Qpr.ProcessAnalyzer.Service.MainService).Assembly.GetName().Version;
  Response.Write(version.Major + "." + version.Minor + "." + version.Build + "." + version.Revision);
%>
    </div>
    <div style="float: right;">
      QPR Software &copy; 2020 | <a href="http://www.qpr.com">www.qpr.com</a> | <a href="https://processanalyzer.onqpr.com">processanalyzer.onqpr.com</a>
    </div>
  </div>
</body>
</html>